xquery version "3.1";

module namespace transformXML="https://sade.textgrid.de/ns/transform";
import module namespace console="http://exist-db.org/xquery/console";

declare boundary-space strip;
declare namespace tei="http://www.tei-c.org/ns/1.0";
declare namespace xhtml="http://www.w3.org/1999/xhtml";
declare namespace tg="http://textgrid.info/namespaces/metadata/core/2010";
declare namespace functx = "http://www.functx.com";
declare default element namespace "http://www.w3.org/1999/xhtml";

declare function transformXML:importEdition($tguri as xs:string) {
(:getEdition itself and store in html pages:)
(:    transformXML:storeInPages('34zmq','34zmq'):)

(:getManifest?:)


(:getEdition and prepare xml files in pages? Module&Function still missing:)

let $output := 'done'
return $output
};

declare function functx:reverse-string ( $arg as xs:string? )  as xs:string {
   codepoints-to-string(reverse(string-to-codepoints($arg)))
};
declare function functx:repeat-string( $stringToRepeat as xs:string?,$count as xs:integer )  as xs:string {

   string-join((for $i in 1 to $count return $stringToRepeat),
                        '')
 } ;
declare function functx:pad-integer-to-length( $integerToPad as xs:anyAtomicType? , $length as xs:integer )  as xs:string {

   if ($length < string-length(string($integerToPad)))
   then error(xs:QName('functx:Integer_Longer_Than_Length'))
   else concat
         (functx:repeat-string(
            '0',$length - string-length(string($integerToPad))),
          string($integerToPad))
 } ;
declare function functx:date( $year as xs:anyAtomicType,$month as xs:anyAtomicType,$day as xs:anyAtomicType ) as xs:date {
xs:date(
 concat(
   functx:pad-integer-to-length(xs:integer($year),4),'-',
   functx:pad-integer-to-length(xs:integer($month),2),'-',
   functx:pad-integer-to-length(xs:integer($day),2)))
};

declare function local:castDate($string) {
    let $result := tokenize($string, '-')
    let $date := functx:date($result[1],$result[2],$result[3])
    let $ouput := string-join((fn:day-from-date($date),fn:month-from-date($date),fn:year-from-date($date)),'-')
    return $ouput
};

declare function local:milestone-chunk-ns(
  $ms1 as element(),
  $ms2 as element(),
  $node as node()*
) as node()*
{
  typeswitch ($node)
    case element() return
      if ($node is $ms1) then $node
      else if ( some $n in $node/descendant::* satisfies ($n is $ms1 or $n is $ms2) )
      then
        (: element { name($node) } :)
           element {QName (namespace-uri($node), name($node))}
                { for $i in ( $node/node() | $node/@* )
                  return local:milestone-chunk-ns($ms1, $ms2, $i) }
      else if ( $node >> $ms1 and $node << $ms2 ) then $node
      else ()
    case attribute() return $node (: will never match attributes outside non-returned elements :)
    default return 
      if ( $node >> $ms1 and $node << $ms2 ) then $node
      else ()
};
declare function local:milestone-chunk-ns-last(
  $ms1 as element(),
  $ms2 as element(),
  $node as node()*
) as node()*
{
  typeswitch ($node)
    case element() return
      if ($node is $ms1) then $node
      else if ( some $n in $node/descendant::* satisfies ($n is $ms1 or $n is $ms2) )
      then
        (: element { name($node) } :)
           element {QName (namespace-uri($node), name($node))}
                { for $i in ( $node/node() | $node/@* )
                  return local:milestone-chunk-ns-last($ms1, $ms2, $i) }
      else if ( $node >> $ms1 and $node << $ms2 ) then ($node)
      else if ($node is $ms2) then ( $ms2 )
      else ()
    case attribute() return $node (: will never match attributes outside non-returned elements :)
    default return 
      if ( $node >> $ms1 and $node << $ms2 ) then $node
      else ()
};

declare function local:countPB($length) {
    let $pbNumbers := for $i in 1 to $length
    return $i
    
    return string-join($pbNumbers,',')
};

declare function local:countFW($length,$body) {
    let $fwNumbers := for $i in 1 to $length
    return $body//tei:pb[@n=$i]/following::tei:fw[1]/node()
    
    return string-join($fwNumbers,',')
};

declare function transformXML:storeInPages($filenameInput as xs:string, $filenameOutput as xs:string) {
    let $login := xmldb:login("/db", "admin", "" )
    let $pathInput := '/db/apps/sade-architrave/textgrid/data'
    let $pathOutput := '/db/apps/sade-architrave/templates/'||$filenameInput
    let $doc := doc($pathInput||'/'||$filenameInput||'.xml')

    let $doc3 := doc($pathInput||'/'||$filenameInput||'.xml')
    let $header := transformXML:magicForHeader($doc3//tei:TEI/*)

    let $pathInput := '/db/apps/sade-architrave/textgrid/meta'
    let $doc2 := doc($pathInput||'/'||$filenameInput||'.xml')
    let $metadata := local:magicForMetadata($doc2/*)

    let $input := $doc//tei:TEI/tei:text//tei:body
    let $counterPages := count($input//tei:pb)
    let $pbNumbers := ''
    let $fwNumbers := ''
    
    let $pbNumbers := local:countPB($counterPages)
    let $fwNumbers := local:countFW($counterPages,$input)
    
    for $i in 1 to $counterPages
        return
            if ($i < $counterPages) then (
                let $first := $i
                let $next := $i+1
                let $output := local:milestone-chunk-ns($input//tei:pb[@n=string($first)],$input//tei:pb[@n=string($next)],$input)
                let $output := local:magic($output)
                let $filenameOutputPage := $filenameOutput || '_p' || string($i)
                let $output := <div>{$metadata}<div id="tei-header"><span style="display:none" id="pbNumbers">{$pbNumbers}</span><span style="display:none" id="fwNumbers">{$fwNumbers}</span>{$header}</div>{$output}</div>
                let $store := xmldb:store($pathOutput, $filenameOutputPage || '.html' , $output )
                return $output
            )
            else (
                let $output := local:milestone-chunk-ns-last($input//tei:pb[@n=string($counterPages)], ($input//tei:pb[@n="1"]/following-sibling::*[last()]),$input)
                let $output := local:magic($output)
                let $filenameOutputPage := $filenameOutput || '_p' || string($i)
                let $output := <div>{$metadata}<div id="tei-header"><span style="display:none" id="pbNumbers">{$pbNumbers}</span><span style="display:none" id="fwNumbers">{$fwNumbers}</span>{$header}</div>{$output}</div>
                let $store := xmldb:store($pathOutput, $filenameOutputPage || '.html' , $output )
                return $output
            )
};

declare function transformXML:store($filenameInput as xs:string, $filenameOutput as xs:string) {

    let $pathInput := '/db/apps/sade-architrave/textgrid/data'
    let $pathOutput := '/db/apps/sade-architrave/templates'
    let $doc := doc($pathInput||'/'||$filenameInput||'.xml')
    let $xml := local:magic($doc/*)

    let $numberOfPages := $doc//tei:pb 

    let $pathInput := '/db/apps/sade-architrave/textgrid/meta'
    let $doc2 := doc($pathInput||'/'||$filenameInput||'.xml')
    let $metadata := local:magicForMetadata($doc2/*)

    let $result := <div data-template="templates:surround" data-template-with="templates/edition_surround.html" data-template-at="edition-container">{$metadata}{$xml}</div>

    let $login := xmldb:login("/db", "admin", "" )
    let $store := xmldb:store($pathOutput, $filenameOutput || '.html' , $result )

    return $result
};

declare function local:magicForMetadata($nodes) {
    for $node in $nodes
return
typeswitch ( $node )
    case element( tg:MetadataContainerType ) return ( local:magicForMetadata($node/node()) )
    case element( tg:object ) return ( local:magicForMetadata($node/node()) )
    case element( tg:generic ) return ( local:magicForMetadata($node/node()) )
    case element( tg:generated ) return ( local:magicForMetadata($node/node()) )
    case element( tg:created ) return
        <span style="display:none" id="tei-meta-dateCreated">{ string($node) }</span>
    case element( tg:lastModified ) return
        <span style="display:none" id="tei-meta-dateModified">{ string($node) }</span>
    case element( tg:textgridUri ) return
        <span style="display:none" id="tei-meta-textGridURI">{ string($node) }</span>
    case element( tg:pid ) return
        <span style="display:none" id="tei-meta-pid">{ string($node) }</span>
    default return ()
};

declare function transformXML:toHTML($file as xs:string) {

    let $doc := doc($file)
    let $result := local:magic($doc/*)

    return $result
};

declare function transformXML:magicForHeader($nodes) {
for $node in $nodes
return
typeswitch ( $node )
    case element( tei:teiHeader ) return ( transformXML:magicForHeader($node/node()) )
    case element( tei:fileDesc ) return ( transformXML:magicForHeader($node/node()) )
    case element( tei:titleStmt ) return ( transformXML:magicForHeader($node/node()) )
    case element( tei:title ) return
        <h4 id="tei-title-{string($node/@type)}-{string($node/@xml:lang)}" style="display:none" class="maintitle lang-{string($node/@xml:lang)} type-{string($node/@type)}" type="{string($node/@type)}" xml:lang="{string($node/@xml:lang)}">{ string($node) }</h4>
    case element( tei:author ) return
        <span style="display:none" id="tei-author">{ string($node) }</span>
    default return ()
};

declare function local:magic($nodes) {
for $node in $nodes
return
typeswitch ( $node )
    case element( tei:TEI ) return
        <div class="{$node/local-name()}">
            { local:magic($node/node()) }
        </div>
    case element( tei:text ) return
        <div class="{$node/local-name()}">
            { local:magic($node/node()) }
        </div>
    case element( tei:body ) return
        <div class="{$node/local-name()}">
            { local:magic($node/node()) }
        </div>
    case element ( tei:div ) return
        <div class="{$node/local-name()}" type="{string($node/@type)}">
            { local:magic($node/node()) }
        </div>
    case element ( tei:p ) return
        <p>{ local:magic($node/node()) }</p>
    case element ( tei:pb ) return
        <span id="page{string($node/@n)}" class="pb" facs="{ string($node/@facs) }">{ string($node/@n) }</span>
    case element ( tei:fw ) return
        if (string($node/@place) = 'top-right') then ( 
            <div class="tei-fw" style="text-align:left"><span class="fw {string($node/@place)}">{ string($node) }</span></div>
        )
        else (
            <div class="tei-fw" style="text-align:left"><span class="fw {string($node/@place)}">{ string($node) }</span></div>
        )
    case element ( tei:choice ) return
        if (string('') = string('')) then (
            <abbr class="abbr-yes" style="display:inline" title="{$node/tei:expan}">{ local:magic($node/tei:abbr) }</abbr>,
            <abbr class="abbr-no" style="display:none" title="{$node/tei:abbr}">{ local:magic($node/tei:expan) }</abbr>
        )
        else ()
    case element (tei:date) return
        <span class="tei-date" data-toggle="tooltip" data-placement="bottom" title="{local:castDate(string($node/@when))}">{local:magic($node/node())}<i class="far fa-calendar-alt"></i></span>(: put a span around! is this ok?  :)
    case element ( tei:lb ) return
        <br/>
    case element ( tei:hi ) return
        <span class="hi {string($node/@rend)}" rend="{string($node/@rend)}">{ local:magic($node/node()) }</span>
    case element ( tei:supplied ) return
        <span class="tei-add"><span class="tei-add-bracket">⟨</span>{string($node)}<span class="tei-add-bracket">⟩</span></span>
    case element ( tei:placeName ) return
        if (($node/@subtype) = 'rooms') then (
            <span class="placeName">{local:magic($node/node())}</span>,
            <a class="placeName" onclick="openPlaceName('{substring-before(string($node/@ref),' ')}')" textgridURI="{substring-before(string($node/@ref),' ')}">
                <i class="fas fa-map-marker-alt"></i>
            </a>,     
            <a class="placeName" onclick="openPlaceName('{substring-after(string($node/@ref),' ')}')" textgridURI="{substring-after(string($node/@ref),' ')}">
                <i class="fas fa-map-marker-alt"></i>
            </a>
        )
        else (
            <a class="placeName" onclick="openPlaceName('{string($node/@ref)}')" textgridURI="{$node/@ref}">
                <span class="placeName">{local:magic($node/node())}</span>
                <i class="fas fa-map-marker-alt"></i>
            </a>
        )
    case element ( tei:geogName ) return
        <a class="placeName" onclick="openPlaceName('{string($node/@ref)}')" textgridURI="{$node/@ref}">
            <span class="placeName">{local:magic($node/node())}</span>
            <i class="fas fa-map-marker-alt"></i>
        </a>
    case element ( tei:persName ) return
        if (($node/@subtype) = 'persons') then (
            <span class="persName">{local:magic($node/node())}</span>,
            <a class="persName" onclick="openPersName('{substring-before(string($node/@ref),' ')}')" textgridURI="{substring-before(string($node/@ref),' ')}">
                <i class="fas fa-user"></i>
            </a>,     
            <a class="persName" onclick="openPersName('{substring-after(string($node/@ref),' ')}')" textgridURI="{substring-after(string($node/@ref),' ')}">
                <i class="fas fa-user"></i>
            </a>
        )
        else if (($node/@subtype) = 'family') then (
            <a class="persName" onclick="openPersName('{string($node/@ref)}')" textgridURI="{$node/@ref}">
                <span class="persName">{local:magic($node/node())}</span>
                <i class="fas fa-users"></i>
            </a>       
        )
        else (
            <a class="persName" onclick="openPersName('{string($node/@ref)}')" textgridURI="{$node/@ref}">
                <span class="persName">{local:magic($node/node())}</span>
                <i class="fas fa-user"></i>
            </a>
        )
    case element ( tei:rs ) return 
        if (string($node/@type) = 'artwork') then ( 
            <a class="ArtWork" onclick="openArtWork('{string($node/@ref)}')" textgridURI="{$node/@ref}">
                <span class="ArtWork">{local:magic($node/node())}</span>
                <i class="far fa-gem"></i>                
            </a>
            )
        else ()
    case element ( tei:del ) return
        <span class="del"><strike>{string($node)}</strike></span>
    case element ( tei:unclear ) return
        <span class="unclear">{string($node)}[?]</span>
    case element ( tei:space ) return
        if (string($node/@extent) = '1word') then ( <span style="margin-right:1.25em;display:inline-block" class="tei-1word"></span> )
        else if (string($node/@extent) = '2word') then ( <span style="margin-right:2.5em;display:inline-block" class="tei-1word"></span> )
        else ()
    case element ( tei:num ) return
        if (string($node/@type) = 'fraction') then (
            if (string($node/@rend) = 'horizontal') then ( 
                <span class="tei-fraction-horizontal">
                    <math xmlns="http://www.w3.org/1998/Math/MathML" display="inline">
                      <mrow>
                        <mfrac>
                          <mrow>
                            <mn>{fn:substring-before(string($node/node()),'/')}</mn>
                          </mrow>
                          <mrow>
                            <mn>{fn:substring-after(string($node/node()),'/')}</mn>
                          </mrow>
                        </mfrac>
                      </mrow>
                    </math>
                </span>
            )
            else if (string($node/@rend) = 'oblique') then (
                local:magic($node/node())
            )
            else if (string($node/@rend) = 'diagonal') then (
                <span class="tei-fraction-oblique">
                    <sup>{fn:substring-before(string($node/node()),'/')}</sup>
                    /
                    <sub>{fn:substring-after(string($node/node()),'/')}</sub>
                </span>
            )
            else ()
        )
        else if ((string($node/@type) = 'fractionLike') and (string($node/@rend) = 'horizontal')) then (
            <span class="abbr-yes tei-fraction-horizontal" style="display:inline">
                <math xmlns="http://www.w3.org/1998/Math/MathML" display="inline">
                  <mrow>
                    <mfrac>
                      <mrow>
                        <mn>{string($node/tei:choice/tei:abbr/node())}</mn>
                      </mrow>
                      <mrow>
                        <mn>{fn:substring-after($node/text(),'/')}</mn>
                      </mrow>
                    </mfrac>
                  </mrow>
                </math>
            </span>,
            <span class="abbr-no tei-fraction-horizontal" style="display:none">
                <math xmlns="http://www.w3.org/1998/Math/MathML" display="inline">
                  <mrow>
                    <mfrac>
                      <mrow>
                        <mn>{string($node/tei:choice/tei:expan/node())}</mn>
                      </mrow>
                      <mrow>
                        <mn>{fn:substring-after($node/text(),'/')}</mn>
                      </mrow>
                    </mfrac>
                  </mrow>
                </math>
            </span>
        )
        else ( local:magic($node/node()) )
    case element ( tei:q ) return
        <span class="tei-quote">{string($node)}</span>
    case element ( tei:add ) return
        <span class="tei-quote">{string($node)}</span>
    case element ( tei:teiHeader ) return (transformXML:magicForHeader($node))
    case text() return
        if( matches($node, "^\s+$") and not($node/parent::tei:p) ) then ()
        else if (matches($node, "&#11840;")) then (
            <span>{fn:substring-before($node,"&#11840;")}</span>,
            <span class="double-hyphen">&#61;</span>,
            <span>{fn:substring-after($node,"&#11840;")}</span>
        )
        else
        <span class="txt">{$node}</span>
    case element ( tei:note ) return
        if ( string($node/@type) = "translation") then (
            <a class="translationComment" onclick="openScientificComment('{string($node//text())}')">
                <i class="fas fa-comment"/>
            </a>
        )
        else if ( string($node/@type) = "scientific") then (
            <a class="scientificComment" onclick="openTranslationComment('{string($node//text())}')">
                <i class="fas fa-comment"/>   
            </a>   
        )
        else if ( string($node/@type) = "editorial") then (
            <a class="editorialComment" onclick="openEditorialComment('{string($node//text())}')">
                <i class="far fa-comment"/>   
            </a>   
        )
        else ()
    default return
        local:magic($node/node())
};
