/* Checkbox functions for display options */
$(".checkbox").change(function(e) {
    e.stopPropagation();
    console.log("checkbox change");
    var id = $(this).attr("id")
    var checkValue = $(this)
        .find("input")
        .is(":checked")
    console.log(id + "=" + checkValue)
    //Hier: Icons ausblenden:
    switch (id) {
        case 'placeNames':
            console.log('placeNames');
            triggerSVGVisibility(".placeName svg");
            break;
        case 'persNames':
            console.log('persNames');
            triggerSVGVisibility(".persName svg");
            break;
        case 'workNames':
            console.log('workNames');
            triggerSVGVisibility(".ArtWork svg");
            break;
        case 'scientificComments':
            console.log('scientificComments');
            triggerSVGVisibility(".scientificComment svg");
            triggerSVGVisibility(".translationComment svg");
            triggerSVGVisibility(".editorialComment svg");
            break;
        case 'origSpelling':
            console.log('origSpelling');
            triggerSVGVisibility(".abbr-yes");
            triggerSVGVisibility(".abbr-no");
            break;
        case 'abbreviations':
            console.log('abbreviations');
            triggerSVGVisibility(".tei-add");
            break;
        case 'dates':
            console.log('dates');
            triggerSVGVisibility(".tei-date svg");
            break;
        case 'showAll':
            console.log('showAll');
            if ($('#placeNames input').is(":checked") != checkValue) {
                $('#placeNames input').click();
            }
            if ($('#persNames input').is(":checked") != checkValue) {
                $('#persNames input').click();
            }
            if ($('#workNames input').is(":checked") != checkValue) {
                $('#workNames input').click();
            }
            if ($('#origSpelling input').is(":checked") != checkValue) {
                $('#origSpelling input').click();
            }
            if ($('#abbreviations input').is(":checked") != checkValue) {
                $('#abbreviations input').click();
            }
            if ($('#dates input').is(":checked") != checkValue) {
                $('#dates input').click();
            }
            break;
        default:
            console.log("nix")
            break;
    }
});

function triggerSVGVisibility(classtype) {
    console.log("trigger: " + classtype);
    if (
        $(classtype).css("display") == "none"
    ) {
        $(classtype).css("display", "inline")
    } else {
        $(classtype).css("display", "none")
    }
}

/* Activate tooltips (only hovering!) */
$(function() {
    $('[data-toggle="tooltip"]').tooltip({
        trigger: "hover"
    });
});

function getParameter(parameterName) {
    var result = null,
        tmp = [];
    location.search
        .substr(1)
        .split("&")
        .forEach(function(item) {
            tmp = item.split("=");
            if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
        });
    return result;
}

function setParameter(key, value) {
    const params = new URLSearchParams(location.search);
    params.set(key, value);
    window.history.pushState({}, '', `${location.pathname}?${params}`);
}

/* Page change: no page refresh when submit input */
function checkNumber(value) {
    var er = /^-?[0-9]+$/
    return er.test(value)
}

function setNewPage(newPage) {
    if (checkNumber(newPage)) {
        setParameter('page', newPage);
        triggerPageIcon(false);
        updatePage();
    } else {
        console.log("not a valid number");
    }
}

function updatePage() {
    var currentPage = getParameter('page');
    loadPage(getParameter('edition'), currentPage);
}

function pageForward() {
    var currentPage = getParameter('page');
    var temp = parseInt(currentPage) + 1;
    var newPage = temp.toString();
    setNewPage(newPage);
}

function pageBack() {
    var currentPage = getParameter('page');
    var temp = parseInt(currentPage) - 1;
    var newPage = temp.toString();
    setNewPage(newPage);
}

/*updatePage();  <= disabled because it triffers page load twice! */ 

/* Do not show Arrows for next/before page if its the last or first page. */
function setBtnPage(btn,status) {
    if (btn == 'forward') {btn = '#btn-page-forward'}
    else if (btn == 'back') {btn = '#btn-page-back'}
    else {console.log('error: no such button')}
    
    if (status == true) {
        $(btn).css("display", "block");
        btn = btn+'-disabled';
        $(btn).css("display", "none");
    }
    else if (status == false) {
        $(btn).css("display", "none");
        btn = btn+'-disabled';
        $(btn).css("display", "block");
    }
    else {console.log('error: no such status')}
}
function checkForPossibleNeighbourPages(number) {
    
    var allNumbers = sessionStorage.getItem('pbNumbers').split(',');
    var first = allNumbers[0];
    var last = allNumbers[allNumbers.length - 1];
    
    setBtnPage('forward',true);
    setBtnPage('back',true);
    
    if (number == first) {
        setBtnPage('back',false);
    } else if (number == last) {
        setBtnPage('forward',false);
    } else {}
}

/* Page Number Stuff */
function addLiElement(number, fw) {
    $('#ulPageNumbers').append('<li class="pageElement"><a href="#" onclick="setNewPage(' + number + ');this.blur();return false;"><span>' + number + ' (' + fw + ')</span></a></li>');
}

function deleteAllLis() {
    var ul = document.getElementById('ulPageNumbers');
    if (ul) {
        while (ul.firstChild) {
            ul.removeChild(ul.firstChild);
        }
    }
}

function addAllPages() {
    setTimeout(function(){
        deleteAllLis();
    var allNumbers;
    allNumbers = sessionStorage.getItem('pbNumbers').split(',');
    var allFWNumbers;
    allFWNumbers = sessionStorage.getItem('fwNumbers').split(',');
    $('#ulPageNumbers').append('<li class="pageElement dropdown-header"><strong><span>Pages</span></strong></li>');
    for (var i = 0; i < allNumbers.length; i++) {
        addLiElement(allNumbers[i], allFWNumbers[i])
    }
}, 2000);


}

/* View in fullscreen */
var elem = document.documentElement;

function openFullscreen() {
    if (elem.requestFullscreen) {
        elem.requestFullscreen();
    } else if (elem.mozRequestFullScreen) { /* Firefox */
        elem.mozRequestFullScreen();
    } else if (elem.webkitRequestFullscreen) { /* Chrome, Safari and Opera */
        elem.webkitRequestFullscreen();
    } else if (elem.msRequestFullscreen) { /* IE/Edge */
        elem.msRequestFullscreen();
    }
}

/* Close fullscreen */
function closeFullscreen() {
    if (document.exitFullscreen) {
        document.exitFullscreen();
    } else if (document.mozCancelFullScreen) { /* Firefox */
        document.mozCancelFullScreen();
    } else if (document.webkitExitFullscreen) { /* Chrome, Safari and Opera */
        document.webkitExitFullscreen();
    } else if (document.msExitFullscreen) { /* IE/Edge */
        document.msExitFullscreen();
    }
}
/* Fullscreen button: toggles top navbar and footer + container-fluid */
function triggerFullscreenButton() {
    document.getElementById("icon-fullscreen").children[0].classList.toggle("fa-expand");
    document.getElementById("icon-fullscreen").children[0].classList.toggle("fa-compress");

    /* Hide/Show footer, top navbar and wrapper element */
    var footer = document.getElementById("footer");
    footer.style.display = footer.style.display === "none" ? "" : "none";
    var fullscreenWrapper = document.getElementById("fullscreenWrapper");
    fullscreenWrapper.style.display = fullscreenWrapper.style.display === "none" ? "" : "none";
    var navbar = document.getElementById("navbar-top");
    navbar.style.display = navbar.style.display === "none" ? "" : "none";
    var placeholder = document.getElementById("navbar-placeholder");
    placeholder.style.display = placeholder.style.display === "none" ? "" : "none";
}

function fullscreen() {
    if (document.getElementById("icon-fullscreen").children[0].classList.contains("fa-expand")) {
        openFullscreen();
    } else {
        closeFullscreen();
    }
}
if (document.addEventListener) {
    document.addEventListener('webkitfullscreenchange', exitHandler, false);
    document.addEventListener('mozfullscreenchange', exitHandler, false);
    document.addEventListener('fullscreenchange', exitHandler, false);
    document.addEventListener('MSFullscreenChange', exitHandler, false);
}

function exitHandler() {
    if (document.webkitIsFullScreen === false) {
        triggerFullscreenButton();
    } else if (document.mozFullScreen === false) {
        triggerFullscreenButton();
    } else if (document.msFullscreenElement === false) {
        triggerFullscreenButton();
    } else if (document.webkitIsFullScreen === true) {
        triggerFullscreenButton();
    } else if (document.mozFullScreen === true) {
        triggerFullscreenButton();
    } else if (document.msFullscreenElement === true) {
        triggerFullscreenButton();
    }
}

function toggleLoader() {
    var yourUl = document.getElementById("loader");
    yourUl.style.display = yourUl.style.display === 'none' ? '' : 'none';
    yourUl = document.getElementById("loaderWrapper");
    yourUl.style.display = yourUl.style.display === 'none' ? '' : 'none';
}

/* Increase/Decrease Font-Size Buttons */
function changeFont(change) {
    var currentFontSize = localStorage.getItem("fontSize");
    var newFontSize;
    if (currentFontSize == null) {
        currentFontSize = "140"
    }

    newFontSize = (parseInt(currentFontSize) + change).toString();
    localStorage.setItem("fontSize", newFontSize);
    newFontSize = newFontSize + "%"
    $("#edition-container").css("font-size", newFontSize);
}

function resetFont() {
    $("#edition-container").css("font-size", "140%");
    localStorage.setItem("fontSize", "140");
}

function increaseFont() {
    changeFont(10);
}

function decreaseFont() {
    changeFont(-10);
}
resetFont();

function loadBrowserHistory() {
    updatePage();
}

/* A click on FA-icons and -links displays a modal */
function openRegister(textGridURI) {
    console.log(textGridURI);
    $("#myModalLabel").text(textGridURI);
    $("#myModal").modal("show");
}

function openPersName(textGridURI) {
    openRegister(textGridURI);
}

function openPlaceName(textGridURI) {
    openRegister(textGridURI);
}

function openArtWork(textGridURI) {
    openRegister(textGridURI);
}
function openScientificComment(comment) {
    openModalForComment("scientific",comment);
}
function openTranslationComment(comment) {
    openModalForComment("translation",comment);
}
function openEditorialComment(comment){
    openModalForComment("editorial",comment);
}
function openModalForComment(type,comment) {
    $("#ModalCommentLabel").text("Note type: "+type);
    $("#ModalCommentText").text(comment);
    $("#ModalComment").modal("show"); 
}