/* Test browser and version because of compatibility of
-URLSearchparams
-
*/
function alertOldVersion() {
    alert("Your browser version is out of date. Please update your browser.");
}
function alertUnsupportedBrowser() {
    alert("Your Browser is not supported. Please use Firefox, Chrome or Safari.");
}
function doFinalBrowserTest() {
    if ($.browser.desktop) {
        if ($.browser.chrome) {
            if ($.browser.chrome.version <= 50) {alertOldVersion();}
        }
        else if ($.browser.firefox) {
            if ($.browser.firefox.version <= 45) {alertOldVersion();}
        }
        else if ($.browser.safari) {
            if ($.browser.safari.version <= 10) {alertOldVersion();}
        }
        else {alertUnsupportedBrowser()}
    }
    else if ($.browser.mobile) {
        /* does it work for mobile?? */
        /* migrate docs here https://github.com/gabceb/jquery-browser-plugin/blob/master/dist/jquery.browser.js and here https://github.com/gabceb/jquery-browser-plugin */
    }
    else {alertUnsupportedBrowser()}
}
doFinalBrowserTest();

/* Image Viewer Rezise */
function resetImageViewer() {
    var imgContainerParentHeight = $('#container-img').parent('.lm_content').css('height');
    var imgContainerParentWidth = $('#container-img').parent('.lm_content').css('width');
    var imgContainerWidth;
    var imgContainerHeight;
    var margin = 20;
    
    if (imgContainerParentHeight > imgContainerParentWidth) {
        imgContainerWidth = (parseInt(imgContainerParentWidth) - margin).toString() + 'px';
        $('#container-img').css('width',imgContainerHeight);
        $('#container-img').css('height','96%');        
    }
    else {
        imgContainerHeight = (parseInt(imgContainerParentHeight) - margin).toString() + 'px';
        $('#container-img').css('height',imgContainerHeight);
        $('#container-img').css('width','96%');
    }
    
    viewer.refresh();
}

/* Top Bar Functions */

/* Dropdown menu: Deactivate close function when clicking on checkbox */
$("#dropdown-menu").click(function(e) {
	e.stopPropagation()
});

/* Other Buttons */
function toggleBtnColor(section,status) {
    colorOn = '#3299bb';
    colorOff = '#EEE9DF';
    if (status == 'on') { color = colorOn }
    else if (status == 'off') { color = colorOff }
    $(section).css('border-bottom-color',color);
}

function countActiveComponents() {
    var result=0;
    result = myLayout.root.getComponentsByName('facs').length + myLayout.root.getComponentsByName('tran').length + myLayout.root.getComponentsByName('translation').length + myLayout.root.getComponentsByName('code').length;
    
    return result;
}
function toggleComponent(section) {

    var countComponents = countActiveComponents();
    var sectionbutton = '#btn-'+section;
    if (myLayout.root.getItemsById(section)[0] == undefined) {
        console.log("open container");
        goldenActivate(section);
        toggleBtnColor(sectionbutton,'on');
    }
    else {
        if ((section == 'tran') && (myLayout.root.getComponentsByName('tran').length == 1) && (myLayout.root.getComponentsByName('translation').length  == 0)) {
            alert('Error: Edition or Translation must be open to get facs.');
        }
        else if ((section == 'translation') && (myLayout.root.getComponentsByName('translation').length == 1) && (myLayout.root.getComponentsByName('tran').length  == 0)) {
            alert('Error: Edition or Translation must be open to get facs.');
        }
        else if (parseInt(countComponents) > 2) {
            goldenDestroy(section);
            toggleBtnColor(sectionbutton,'off');
        }
        else {
            console.log('SORRY, there must be at least two components left.')
            alert('Error: There must be at least two components left.');
        }
    }
    resetImageViewer()
}
function btnFacs() {
    toggleComponent('facs');
}
function btnEdition() {
    toggleComponent('tran');
}
function btnTranslation() {
    toggleComponent('translation');
}
function btnCode() {
    toggleComponent('code');
}

/* JS Code for goldenLayout */

var facs = {
    type: 'component',
    width:30,
    componentName: 'facs',
    id: 'facs',
    isClosable: false,
    title: '<i class="fas fa-2x fa-fw fa-image"></i>',
    componentState: { label: "<div style='text-align:center; margin:auto; width: 96%; top: 50%; transform: translateY(-50%); position: relative;height: calc(100vh - 190px);' id='container-img'></div><script src='templates/js/imageviewer.min.js'/><script>var viewer = ImageViewer('#container-img',{zoomValue:100,maxZoom:1500})</script>" }
    /* componentState: { label: "<div style='margin:10px;'><img id='image' style='width:auto;height:100%;' src='https://textgridlab.org/1.0/digilib/rest/IIIF/textgrid:398j4.0/full/max/0/default.jpg'></img></div><script src='templates/js/imageviewer.min.js'/><script>var viewer = ImageViewer('#image',{zoomValue:100,maxZoom:1000});</script>" } */
}
var tran = {
    type: 'component',
    width: 30,
    componentName: 'tran',
    id: 'tran',
    isClosable: false,
    title: '<i class="fas fa-2x fa-fw fa-align-left"></i>',
    componentState: { label: '<h1>B</h1>' } 
}
var translation = {
    type: 'component',
    componentName: 'translation',
    id: 'translation',
    isClosable: false,
    title: '<i class="fas fa-2x fa-fw fa-exchange-alt"></i>',
    componentState: { label: '<h1>D</h1>' } 
}
var code = {
    type: 'component',
    componentName: 'code',
    id: 'code',
    isClosable: false,
    title: '<i class="fas fa-2x fa-fw fa-code"></i>',
    componentState: { label: 'C' }
}
var config = {
    settings:{
        hasHeaders: true,
        constrainDragToContainer: false,
        reorderEnabled: true,
        selectionEnabled: false,
        popoutWholeStack: false,
        blockedPopoutsThrowError: true,
        closePopoutsOnUnload: true,
        showPopoutIcon: false,
        showMaximiseIcon: false,
        showCloseIcon: false
    },
    dimensions: {
        borderWidth: 5,
        minItemHeight: 10,
        minItemWidth: 10,
        headerHeight: 20,
        dragProxyWidth: 300,
        dragProxyHeight: 200
    },
    labels: {
        close: 'close',
        maximise: 'maximise',
        minimise: 'minimise',
        popout: 'open in new window'
    },
    
    content: [{
        type: 'row',
        id: 'no-drop-target',
        content:[facs,tran]
    }],
    
    id: 'goldenlayout',
    // width: 30,
    // height: 30,
    isClosable: true,
    title: 'some title',
    activeItemIndex: 1
};
var myLayout = new GoldenLayout( config, $('#goldenlayout') );


myLayout.registerComponent( 'facs', function( container, componentState ){
    //container.getElement().html( '<h2>' + componentState.label + '</h2>' );
    container.getElement().html( componentState.label );
    $('#btn-facs').css('border-bottom-color','#3299bb');
});
myLayout.registerComponent( 'code', function( container, componentState ){
    var newElement = '<div class="" id="code-container"/>';
    container.getElement().html( newElement );
    $('#btn-code').css('border-bottom-color','#3299bb');
    $('#code-container').parent().css("overflow-y","scroll");
});
myLayout.registerComponent( 'translation', function( container, componentState ){
    var source = getParameter("translation");
    var page = getParameter("page");
    var nosource = "<h2>Error: No Source Defined</h2>";
    var newElement = '<div class="ftranslation sourceDoc edition-rules" id="translation-container"/>';
    //Check if source in getParameter is defined correctly!
    if ((source == "") || (source==null)){
        newElement = nosource;
        container.getElement().html( newElement );
        console.log("no source defined!");
    }
    else {
        container.getElement().html( newElement );
        $.ajax({
            url: "https://architrave.eu/"+source+"/"+source+"_p"+page+".html"+window.location.search,
            dataType: "text"
            }).done( function(data){
                $(".ftranslation").append(data);
                $(".ftranslation").parent().css("overflow-y","scroll")
            });
    }
});

myLayout.registerComponent( 'tran', function( container, state ){
    var source = getParameter("edition");
    var page = getParameter("page");
    var nosource = "<h2>Error: No Source Defined</h2>";
    var newElement = '<div id="loaderGoldenLayout2" class="loader2" style="padding-top:150px"> <svg class="circular" viewBox="25 25 50 50"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div><div class="ftran sourceDoc edition-rules" id="edition-container"/>';
    //Check if source in getParameter is defined correctly!
    if ((source == "") || (source==null)){
        newElement = nosource;
        container.getElement().html( newElement );
        console.log("no source defined!");
    }
    else {
        container.getElement().html( newElement );
    }
    $('#btn-tran').css('border-bottom-color','#3299bb');
});

function goldenActivate( trigger ){
    console.log('goldenActivate: '+trigger);
    var child;
    var indexNumber =0;
    var activeContentItems = myLayout.root.contentItems[0].contentItems.length;
    if(trigger == 'code') { child = code; indexNumber = activeContentItems; }
    else if(trigger == 'translation') { 
        child = translation;
        if ((countActiveComponents() == activeContentItems) && (myLayout.root.getComponentsByName('code').length == 1)) {
            console.log('HAAALLLLLLLLLLLLOOOOOOOOO true');
            indexNumber = activeContentItems - 1; 
        }
        else { indexNumber = activeContentItems; }
    }
    else if(trigger == 'tran') { 
        child = tran;
        if ((countActiveComponents() == activeContentItems) && (myLayout.root.getComponentsByName('facs').length == 1)) {
            indexNumber = 1; 
        }
        else if (myLayout.root.getComponentsByName('facs').length == 0) {
            indexNumber = 0; 
        }
        else { indexNumber = activeContentItems; }
    }
    else if(trigger == 'toc') { child = toc; }
    else if(trigger == 'facs') { child = facs; indexNumber = 0; }
    
    console.log(indexNumber.toString() + ' of ' + activeContentItems.toString());
    
    myLayout.root.contentItems[0].addChild(child,indexNumber);
    setTimeout(function(){console.log('childcreate');resetImageViewer();loadFacs(getParameter('page'))}, 100);
    var insert;
    switch ( trigger ) {
        case 'code':
            loadCode();
            break;
        case 'tran':
            console.log('trigger tran');
            loadTrans(source,page,container);
            break;
        case 'facs':
            resetImageViewer()
            break;
        default:
            console.log( "unknown trigger" );
    };
}

function goldenDestroy ( id ) {
    myLayout.root.getItemsById( id )[0].remove();
    console.log('goldenDestroy: '+id);
}

$(window).resize( function(){ myLayout.updateSize(); } );
myLayout.init();
$('#loaderGoldenLayout').css('display','none');


/* JS Code for Mirador Viewer */
// FUNCTIONS FIRST
function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
}

//get Manifest from getParameter
function getManifest() {
    var result = null,
        tmp = [];
    location.search
    .substr(1)
        .split("&")
        .forEach(function (item) {
        tmp = item.split("=");
        if (tmp[0] === "manifest") result = decodeURIComponent(tmp[1]);
    });
    return result;
}
var manifest = getManifest();
//dann einfach bei der manifestUri anstatt textgrid:399bv.0 die variable manifest nehmen!!


function loadPage(source,number) {
    console.log('load page number: '+number);
    if (sessionStorage.getItem('edition') == source) {}
    else {sessionStorage.setItem('edition',source);}
    
    setTimeout(function(){
        /* if edition view is enabled */
        if ($("#edition-container").length == '1') {loadTrans(source,number,'#edition-container');}
        
        /* if translation view is enabled */
        if ($("#translation-container").length == '1') {loadTrans(source,number,'#translation-container');}
        
        /* if edition view nor translation view is enabled */
        if (($("#edition-container").length != '1') && ($("#translation-container").length != '1')) {
            
            console.log("didn't found edition view nor translation view => no facs and no xml code");
        };
    },200);

}

function getTrans(container, responseText) {
    $('#loaderGoldenLayout2').css('display','none');
    $(container).html(responseText);
    $(container).parent().css("overflow-y","scroll")
    
    var number = sessionStorage.getItem('number');
    document.getElementById('pageNumber').innerHTML = number;
    sessionStorage.setItem('pbNumbers',document.getElementById('pbNumbers').innerHTML);
    sessionStorage.setItem('fwNumbers',document.getElementById('fwNumbers').innerHTML);
    checkForPossibleNeighbourPages(number);
    
    loadFacs(number);  
}

function fetchStatus( address, container ) {

  var client = new XMLHttpRequest();
  client.timeout = 5000;
  client.onload = function() {
    returnStatus( this.status, container, client.responseText );
  }
  client.open( "GET", address, true );
  client.send();
}

function triggerPageIcon(status) {
    if (status) {
        $('#pageNumberLoader').css('display','none');
        $('#pageNumberError').css('display','none'); 
        $('#pageNumber').css('display','block');
    }
    else {
        $('#pageNumberLoader').css('display','block');
        $('#pageNumberError').css('display','none'); 
        $('#pageNumber').css('display','none');
    }
}

function triggerPageIconError(status) {
    if (status) {
        $('#pageNumberLoader').css('display','none');
        $('#pageNumber').css('display','none'); 
        $('#pageNumberError').css('display','block'); 
    }
}

function returnStatus( status, container, responseText ) {
  if ( status === 200 ) {
    getTrans(container, responseText);
    triggerPageIcon(true);
  }
  else if ( status === 404 ) {
    triggerPageIconError(true);
    alert("Didn't found the file you're looking for. Please check your request for edition and page number (error: "+status+")");
  }
  else {
    triggerPageIconError(true);
    alert('error: ' + status );
  }
}

function loadTrans(source,number,container) {
    try {
        sessionStorage.setItem('edition',source);
        sessionStorage.setItem('number',number);
    }
    catch (e) {console.log(e)}
    var url = "https://architrave.eu/"+source+"/"+source+"_p"+number+".html";
    fetchStatus(url,container);
}

function addEventListenersRezise(classnames) {
    var refreshViewerSize = function() {
        setTimeout(function(){resetImageViewer();}, 10);
    };
    try {
        for (var i = 0; i < classnames.length; i++) {
            classnames[i].addEventListener('mouseup', refreshViewerSize, false);
        }
    }
    catch (e) {console.log(e)}
}

$( document ).ready(function() {
    addAllPages();
    var number = getParameter('page');
    checkForPossibleNeighbourPages(number);
    document.getElementById('pageNumber').innerHTML = number;
    
    $( window ).resize( function(){ myLayout.updateSize(); } );
    
    /* event listeners for drag handlers = rezising imageviewer.js */
    var draghandlers = document.getElementsByClassName("lm_drag_handle");
    addEventListenersRezise(draghandlers);
    /*var draghandlers = document.getElementsByClassName("lm_header");
    addEventListenersRezise(draghandlers); <= does not work correctly*/ 
    
    /* there is an issue (https://github.com/golden-layout/golden-layout/issues/405). they say this helps! */
    myLayout._isFullPage = true;
    /* imageviewer rezise on column create and row create */
    myLayout.on('stackCreated',function(){setTimeout(function(){resetImageViewer();loadFacs(getParameter('page'))}, 10)});
    /* imageviewer rezise on tab create */
    myLayout.on('tabCreated',function(){setTimeout(function(){resetImageViewer();loadFacs(getParameter('page'))}, 100)});
    /*myLayout.on('itemCreated',function(){setTimeout(function(){console.log('itemcreated');resetImageViewer();}, 1000)});
    myLayout.on('itemDestroyed',function(){setTimeout(function(){console.log('itemDestroyed');resetImageViewer();}, 1000)});*/
    
    /*myLayout.on('selectionChanged',function(){setTimeout(function(){console.log('selectionChanged');resetImageViewer();}, 1000)});
    myLayout.on('activeContentItemChanged',function(){setTimeout(function(){console.log('activeContentItemChanged');resetImageViewer();}, 1000)});
    
    myLayout.on('resize',function(){setTimeout(function(){console.log('resize');resetImageViewer();}, 1000)});*/
    
});

function getHeightOfSurroundings() {
    var surroundings = $('#editionTopBar').height();
    surroundings = $('.navbar-header').height() + surroundings;
    surroundings = $('#footer').height() + surroundings;  
    var heightOfGolden = $(document).height() - surroundings;
    return heightOfGolden;
}

function loadFacs(page) {
    var imageurl;
    var imageurllow;
    var imageurlfull;
    var facs;
    try {
        var pbelement = document.getElementById('page'+page);
        facs = pbelement.getAttribute('facs');
        imageurllow = 'https://textgridlab.org/1.0/digilib/rest/IIIF/'+facs+'/full/,100/0/native.jpg';
        imageurlfull = 'https://textgridlab.org/1.0/digilib/rest/IIIF/'+facs+'/full/max/0/default.jpg';
    }
    catch (e) {console.log(e)}
    if ((facs != null) && (facs != '')) {
        viewer.load(imageurllow,imageurlfull);
    }
    else {
        console.log('no valid facs: '+facs);
        viewer.load('https://architrave.eu/templates/img/image_error.svg');
    }
}

function parseCode(status, data) {
  if ( status === 200 ) {
    $('#code-container').html(data);
    $('#code-container').parent().css("overflow-y","scroll");
  }
  else if ( status === 404 ) {
    alert("Didn't found the file you're looking for. Please check your request for edition and page number (error: "+status+")");
  }
  else {
    alert('error: ' + status );
  }
}
function loadCode() {
    var data;
    var source = sessionStorage.getItem('edition');
    var number = sessionStorage.getItem('number');
    var url = "https://architrave.eu/"+source+"/"+source+"_p"+number+"_xml.html";
    
    var client = new XMLHttpRequest();
      client.timeout = 5000;
      client.onload = function() {
        parseCode( this.status, client.responseText );
      }
      client.open( "GET", url, true );
      client.send();
    
    
}
